
    
/* derived from: zooext.c 2.21 88/08/24 02:39:04 */
/*$Source: /usr/home/dhesi/zoo/RCS/zooext.c,v $*/
/*$Id: zooext.c,v 1.9 91/07/09 01:54:13 dhesi Exp $*/
static char sccsid[]="$Source: /usr/home/dhesi/zoo/RCS/zooext.c,v $\n$Id: zooext.c,v 1.9 91/07/09 01:54:13 dhesi Exp $";
   /* LINT */ 

/*
Copyright (C) 1986, 1987 Rahul Dhesi -- All rights reserved
(C) Copyright 1988 Rahul Dhesi -- All rights reserved
(C) Copyright 1991 Rahul Dhesi -- All rights reserved
*/
/* Extract file from archive.  Extracts files specified in parameter-list
   from archive zoo_path.  If none specified, extracts all files from
   archive. */

    
/* @(#) options.h 2.22 88/08/24 15:27:36 */

/*
The contents of this file are hereby released to the public domain.
                           -- Rahul Dhesi 1991/07/06

For documentation about this file, see options.doc.
*/

   /* always defined */
   /* always defined */
   /* always defined */


/***********************************************************************/
/* QNX 4.0                                                             */
/***********************************************************************/

    
   
   
      
   
   
   
   
   
   
   
   
   
   
   
   
   
   
/* #define NEED_MEMCPY */
   /* must be 16 bit unsigned */
   
   /* QNX4  */ 

/***********************************************************************/
/* SYSTEM V (should be compatible with most releases)                  */
/***********************************************************************/

     /* SYS_V */ #line 68 "options.h"

/***********************************************************************/
/* Turbo C++ 1.0 under MS-DOS                                          */
/***********************************************************************/

     /* TURBOC */ #line 113 "options.h"

/***********************************************************************/
/* Older BSD 4.3 and most derivatives                                  */
/***********************************************************************/

     /* BSD4_3 */ #line 140 "options.h"

/*  Ultrix 4.1 */
     /* ULTRIX */ #line 166 "options.h"

/***********************************************************************/
/* Newer BSD 4.4 (projected)                                           */
/***********************************************************************/

     /* BSD4_4 */ #line 193 "options.h"

/***********************************************************************/
/* VAX/VMS version 5.3 or so                                           */
/***********************************************************************/

     /* VMS */ #line 238 "options.h"

/***********************************************************************/
/* AMIGA, SOME VERSION -- NOT TESTED, MAY NEED PORTING                 */
/***********************************************************************/

    #line 262 "options.h"

/***********************************************************************/
/* GENERIC **IX SYSTEM -- GOOD STARTING POINT FOR YOURS                */
/***********************************************************************/

     /* GENERIC */ #line 285 "options.h"


/***********************************************************************/
/* REST OF THIS FILE SHOULD NOT NEED ANY CHANGES                       */
/***********************************************************************/

/***********************************************************************/
/*  Common filename conventions for **IX systems                       */
/***********************************************************************/

    
   
   
   
   
   
  

/* Compensate for strchr/index differences */
    #line 308 "options.h"

/* let non-**IX lints under **IX work (see makefile) */
    #line 318 "options.h"

/* assume certain defaults */
    
    
  

    
    
  
    
    
  
    
    
  
    #line 336 "options.h"
    #line 339 "options.h"

    #line 345 "options.h"

    #line 349 "options.h"

    
     #line 354 "options.h"
  

/* We supply a default for T_UINT16 if it is not defined.  But this
value is critical, so we compile in a runtime check. */

    #line 363 "options.h"

/* ANSI compatibility in declarations -- see zoofns.h for usage */
    
     
       
   #line 371 "options.h"
  
#line 19 "zooext.c"
    
/* derived from: zoo.h 2.16 88/01/27 23:21:36 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/


/* Global data structures and also some information about archive structure.

Among other things, the archive header contains:  

(a) A text message.  In the MS-DOS version this message is terminated by
control Z.  This allows naive users to type the archive to the screen
and see a brief but meaningful message instead of garbage.  The contents of
the text message are however not used by Zoo and they may be anything.  
In particular, the text message may identify the type or archive or the
particular computer system it was created on.  When an archive is packed
by any version of Zoo, the text message is changed to the text message
used by that version.  For example, if Zoo 1.10 packs an archive created
by Zoo 1.31, the text message changes to "Zoo 1.10 archive.".  This
was once considered a shortcoming, but it is now an essential feature,
because packing will also update an old archiver header structure
into a new one.

(b) A four-byte tag that identifies all Zoo archives.  This helps prevent
arbitrary binary files from being treated as Zoo archives.  The tag value is
arbitrary, but seemed to be unlikely to occur in an executable file.  The
same tag value is used to identify each directory entry.  

(c) A long pointer to where in the file the archive starts.  This pointer
is stored along with its negation for consistency checking.  It is hoped
that if the archive is damaged, both the pointer and its negation won't
be damaged and at least one would still be usable to tell us where the 
data begins.

(d) A two-byte value giving the major and minor version number of the
minimum version of Zoo that is needed to fully manipulate the archive.  
As the archive structure is modified, this version number may increase.
Currently version 1.71 of Zoo creates archives that may be fully manipulated
by version 1.40 onwards.

(e) With zoo 2.00 addtional fields have been added in the archive
header to store information about the archive comment and generation
limit.

Version numbering:  
The directory entry of each file will contain the minimum version number of
Zoo needed to extract that file.  As far as possible, version 1.00 of Zoo
will be able to extract files from future version archives.
*/

   /* archive header type */

/* Define major and minor version numbers */
   /* needed to manipulate archive */
   

/* version needed to extract packing method 1 */
   
   

/* version needed to extract packing method 2 */
   
   

   

/* should be 0xFDC4A7DCUL but many c compilers don't recognize UL at end */
   /* A random choice */
   /* Header text for archive. */
   /* Size of header text */

   /* Max length of pathname */
   /* Size of DOS filename */
   /* Size of long filename */
   /* Size of fname without extension */
   /* Size of extension */
   /* Allowing location of file data */
   /* 4 chars plus null */
   /* max packing method we can handle */
   /* extension of backup file */

    #line 88 "zoo.h"

    
   /* argument position of filename list */
  

typedef unsigned char uchar;

/* WARNING:  Static initialization in zooadd.c or zooext.c depends on the 
   order of fields in struct zoo_header */
struct zoo_header {
   char text[ 20];       /* archive header text */ 
   unsigned long zoo_tag;     /* identifies archives */ 
   long zoo_start;            /* where the archive's data starts */ 
   long zoo_minus;      		/* for consistency checking of zoo_start */ 
   uchar major_ver;
   uchar minor_ver;           /* minimum version to extract all files   */ 
	uchar type;						/* type of archive header */ 
	long acmt_pos;					/* position of archive comment */ 
	unsigned int acmt_len;		/* length of archive comment */ 
	unsigned int vdata;			/* byte in archive;  data about versions */ 
};

struct direntry {
   unsigned long zoo_tag;     /* tag -- redundancy check */ 
   uchar type;                 /* type of directory entry.  always 1 for now */ 
   uchar packing_method;       /* 0 = no packing, 1 = normal LZW */ 
   long next;                 /* pos'n of next directory entry */ 
   long offset;               /* position of this file */ 
   unsigned int date;         /* DOS format date */ 
   unsigned int time;         /* DOS format time */ 
   unsigned int file_crc;     /* CRC of this file */ 
   long org_size;
   long size_now;
   uchar major_ver;
   uchar minor_ver;            /* minimum version needed to extract */ 
   uchar deleted;              /* will be 1 if deleted, 0 if not */ 
   uchar struc;                /* file structure if any */ 
   long comment;              /* points to comment;  zero if none */ 
   unsigned int cmt_size; 		/* length of comment, 0 if none */ 
   char fname[ 13]; 		/* filename */ 

   int var_dir_len;           /* length of variable part of dir entry */ 
   uchar tz;                   /* timezone where file was archived */ 
   unsigned int dir_crc;      /* CRC of directory entry */ 

   /* fields for variable part of directory entry follow */
   uchar namlen;               /* length of long filename */ 
   uchar dirlen;               /* length of directory name */ 
   char lfname[ 256];   /* long filename */ 
   char dirname[ 256];    /* directory name */ 
   unsigned int system_id;    /* Filesystem ID */ 
	unsigned long fattr;			/* File attributes -- 24 bits */ 
	unsigned int vflag;			/* version flag bits -- one byte in archive */ 
	unsigned int version_no;	/* file version number if any */ 
};

/* Values for direntry.system_id */
   /* UNIX and similar filesystems */
   /* MS-DOS filesystem */
   /* Portable syntax */

/* Structure of header of small archive containing just one file */

   /* magic number */

     /* ifndef PORTABLE */ #line 169 "zoo.h"

   /* zoo_start in old archives */
   /* minimum size of archive header */
   /* length of current archive header */

/* offsets of items within the canonical zoo archive header */
   /* text in header */
   /* zoo tag */
   /* start offset */
   /* negative of start offset */
   /* major version */
   /* minor version */
   /* archive header type */
   /* position of archive comment */
   /* length of archive comment */
   /* version data */

/* offsets of items within the canonical directory entry structure */
   /* length of type 1 directory entry */
   /* length of type 2 directory entry */
   /* tag within directory entry */
   /* type of directory entry */
   /* packing method */
   /* pos'n of next directory entry */
   /* position (offset) of this file */
   /* DOS format date */
   /* DOS format time */
   /* CRC of this file */
   /* original size */
   /* size now */
   /* major version number */
   /* minor version number */
   /* deleted or not */
   /* file structure */
   /* comment [offset] */
   /* comment size */
   /* filename */
   /* length of var. direntry */
   /* timezone */
   /* CRC of directory entry */

   /* size of stored filename */

/* Offsets within variable part of directory entry */
   
   
   
   /* plus length of filename */

/*
Total size of fixed plus variable directory recognized currently:
One byte each for dirlen and namlen, 256 each for long filename and
directory name, 2 for system id, 3 for file attributes, 1 for 
version flag, 2 for version number, plus a fudge factor of 5.
*/
   

/* Value used to stuff into timezone field if it is not known */
   

/* Value for no file attributes */
   

/* version flag bits */
   /* enable version numbering */
   /* generation count */
   /* last generation of this file */

/* default generation value for archive */
   
/* max generation count, file or archive */
   
/* version mask to prune down to correct size on large-word machines */
   
#line 20 "zooext.c"
    
/* @(#) parse.h 2.1 87/12/25 12:24:15 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/

/*
defines structure used in call to parse()
*/
   /* extra space to avoid off-by-one errors */


struct path_st {
   char drive[2+1+ 2];            /* drive name            */ 
   char dir[ 256+1+ 2];       /* path prefix           */ 
   char fname[8+1+ 2];            /* root name of filename */ 
   char lfname[ 256+1+ 2];  /* long filename    */ 
   char ext[ 3+1+ 2];         /* extension        */ 
};

    #line 26 "parse.h"
void parse();
  
#line 21 "zooext.c"      /* defines struct for parse() */

    
/* @(#) portable.h 2.3 87/12/26 12:25:49 */
/* @(#) portable.h 2.4 88/08/24 00:56:43 */

/* Definitions for portable I/O

The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14



                       DEFINITIONS IN THIS FILE

Symbols:

Z_WRITE, Z_READ, and Z_RDWR are the parameters to supply to zooopen()
and to open an existing file for write, read, and read-write 
respectively.  Z_NEW is the parameter to supply to zoocreate() to
open an existing file or create a new file for write and read.  The
file must be opened in binary format, with no newline translation of
any kind.

Macros or functions:

zgetc(x) reads a character from ZOOFILE x.
zputc(c, f) writes a character to a ZOOFILE x.
zputchar(c) writes a character c to standard output.
MKDIR(x) creates a directory x.
*/

/* Borland's Turbo C. */
    #line 44 "portable.h"

/* Microsoft C 3.0 */
    #line 58 "portable.h"

    #line 69 "portable.h"

    #line 75 "portable.h"

/* Quantum Software's QNX 4 */
    
   /* standard **IX I/O */
      
  

/* **IX System V release 2.1 */
    #line 87 "portable.h"

/* Xenix */
    #line 92 "portable.h"

/* 4.3BSD */
    #line 98 "portable.h"

/* Amiga */
    #line 103 "portable.h"

/* Standard **IX I/O definitions */
    
/* options for zooopen(), zoocreate() */
   
   
   
   
      
         
      
   /* NIX_IO */ 
#line 23 "zooext.c"   /* portable I/O definitions */
    
/* @(#) machine.h 2.1 87/12/25 12:22:43 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/

/* 
This file holds definitions that usually do not change
between different systems, except when using REALLY strange systems.  But
options.h and machine.c hold stuff that does change quite a bit.
*/

/* 
MAXLONG is the maximum size of a long integer.  Right now it doesn't have to
be accurate since it's only used within zooext() to fake infinite disk space.
*/
   

/* 
Type BYTE must hold exactly 8 bits.  The code will collapse badly if BYTE is
anything other than exactly 8 bits. To avoid sign extension when casting
BYTE to a longer size, it must be declared unsigned.  For machine-
independence, Zoo does all I/O of archive headers and directory entries 
in units of BYTE.  The actual file data are not written in units of
BYTE, however, so portability may not be absolute.
*/
typedef  unsigned char BYTE;  /* type corresponding to an 8-bit byte */ 

#line 24 "zooext.c"    /* machine-specific declarations */

    
/* @(#) zooio.h 2.7 88/01/27 19:39:24 */

/*
Declarations for portable I/O

The contents of this file are hereby placed in the public domain.

											-- Rahul Dhesi 1988/01/24
*/
    
        
/*
 *  stdio.h	Standard I/O functions
 *
 *  Copyright (C) by WATCOM Systems Inc. 1988,1989,1990.  All rights reserved.
 *  Copyright (C) by Quantum Software Systems 1990.  All rights reserved.
 */
    
/* remove backwards compatibility feature at a later date */
     /* __STDC__ */ #line 12 "/usr/include/stdio.h"

 #pragma pack(1);

    
    
 typedef unsigned size_t;
  

                     
    
  #line 25 "/usr/include/stdio.h"

    #line 29 "/usr/include/stdio.h"
 typedef char	    *__va_list[1];
  

   /*	Default buffer size		    */
   /*	minimum guaranteed open files	    */
   

typedef struct	__iobuf {
    char	    *_ptr;	    /*	next character position 	    */ 
    int 	     _cnt;	    /*	number of characters left	    */ 
    char	    *_base;	    /*	location of buffer		    */ 
    unsigned	     _flag;	    /*	mode of file access		    */ 
    int 	     _handle;	    /*	file handle			    */ 
    unsigned	     _bufsize;	    /*	size of buffer			    */ 
    unsigned char    _ungotten;     /*	character placed here by ungetc     */ 
    unsigned char    _tmpfchar;     /*	tmpfile number			    */ 
    struct __iobuf  *_link;	    /*	link to next FILE structure	    */ 
} FILE;

typedef long	fpos_t;

   /*	same as _NFILES 		    */

extern	FILE   __near __iob[ 16];
/*
 *  Define macros to access the three default file pointer (and descriptors)
 *  provided to each process by default.  They will always occupy the
 *  first three file pointers in each processes' table.
 */
   /*  standard input file 	    */
   /*  standard output file	    */
   /*  standard error file 	    */

/*  values for _flag field in FILE struct and _iomode array		    */

   /*  file opened for reading	    */
   /*  file opened for writing	    */
   /*  ungetc has been done	    */
   /*  big buffer allocated	    */
   /*  EOF has occurred		    */
   /*  error has occurred on this file */
   /*  not required for POSIX QNX	    */
   /*  file opened for append	    */

   /*  full buffering		    */
   /*  line buffering		    */
   /*  no buffering		    */

   /*  this is a temporary file	    */
   /*  buffer has been modified	    */
   /*  is console device		    */
   /*  FILE is dynamically allocated   */

   /*  End of File/Error return code   */

   /*  Seek relative to start of file  */
   /*  Seek relative to current positn */
   /*  Seek relative to end of file    */

   /*  Max times tmpnam can be called  */
   /*  Max length of tmp file names    */
                      
   /*  Max length of login names	    */
   /*  Max length of terminal names    */
   /*  Temporary file directory	    */
  

void	 clearerr( FILE *__fp );
int	 fclose( FILE *__fp );
int	 feof( FILE *__fp );
int	 ferror( FILE *__fp );
int	 fflush( FILE *__fp );
int	 fgetc( FILE *__fp );
int	 fgetpos( FILE *__fp, fpos_t *__pos );
char	*fgets( char *__s, int __n, FILE *__fp );
FILE	*fopen( const char *__filename, const char *__mode );
int	 fprintf( FILE *__fp, const char *__format, ... );
int	 fputc( int __c, FILE *__fp );
int	 fputs( const char *__s, FILE *__fp );
size_t	 fread( void *__ptr, size_t __size, size_t __n, FILE *__fp );
FILE	*freopen( const char *__filename, const char *__mode, FILE *__fp );
int	 fscanf( FILE*__fp, const char *__format, ... );
int	 fseek( FILE *__fp, long int __offset, int __whence );
int	 fsetpos( FILE *__fp, const fpos_t *__pos );
long int ftell( FILE *__fp );
size_t	 fwrite( const void *__ptr, size_t __size, size_t __n, FILE *__fp );
int	 getc( FILE *__fp );
int	 getchar( void );
char	*gets( char *__s );
void	 perror( const char *__s );
int	 printf( const char *__format, ... );
int	 putc( int __c, FILE *__fp );
int	 putchar( int __c );
int	 puts( const char *__s );
int	 remove( const char *__filename );
int	 rename( const char *__old, const char *__new );
void	 rewind( FILE *__fp );
int	 scanf( const char *__format, ... );
void	 setbuf( FILE *__fp, char *__buf );
int	 setvbuf( FILE *__fp, char *__buf, int __mode, size_t __size );
int	 sprintf( char *__s, const char *__format, ... );
int	 sscanf( const char *__s, const char *__format, ... );
FILE	*tmpfile( void );
char	*tmpnam( char *__s );
int	 ungetc( int __c, FILE *__fp );
int	 vfprintf( FILE *__fp, const char *__format, __va_list __arg );
int	 vprintf( const char *__format, __va_list __arg );
int	 vsprintf( char *__s, const char *__format, __va_list __arg );

               
 int	 fcloseall( void );
 int	 fgetchar( void );
 int	 flushall( void );
 int	 fputchar( int __c );
 int	 vfscanf( FILE *__fp, const char *__format, __va_list __arg );
 int	 vscanf( const char *__format, __va_list __arg );
 int	 vsscanf( const char *__s, const char *__format, __va_list __arg );
  

                      
 char	*ctermid( char * );
 char	*cuserid( char * );
 FILE	*fdopen( int __handle, const char *__mode );
 FILE	*popen( const char *__filename, const char *__mode );
 int	 pclose( FILE *stream );
  

               
 extern int _input_line_max;		/* defaults to 20 */ 

 char	*input_line( FILE *, char *, int );
  

      
      
      
      
     
      
      
        

 #pragma pack();

   
   /* __STDC__ */ 
  
#line 12 "zooio.h"
   
  

    #line 22 "zooio.h"

/*
In theory, all I/O using buffered files could be replaced with unbuffered
I/O simply by changing the following definitions.  This has not been tried
out yet, and there may be some remaining holes in the scheme.  On systems
with limited memory, it might prove necessary to use unbuffered I/O
only.
*/
typedef FILE *ZOOFILE;
   
   /* or any unique value */
   

    
   
  

    
            
            
            
      
   /* IO_MACROS */ #line 51 "zooio.h"

ZOOFILE zooopen  (char *, char *);
ZOOFILE zoocreate  (char *);
int zooclose  (ZOOFILE);
int zootrunc  (ZOOFILE);

char *choosefname  (struct direntry *);
char *fullpath  (struct direntry *);
int frd_zooh  (struct zoo_header *, ZOOFILE);
int frd_dir  (struct direntry *, ZOOFILE);
int fwr_dir  (struct direntry *, ZOOFILE);
int fwr_zooh  (struct zoo_header *, ZOOFILE);
int readdir  (struct direntry *, ZOOFILE, int);
void rwheader  (struct zoo_header *, ZOOFILE, int);
void newdir  (struct direntry *);
void writedir  (struct direntry *, ZOOFILE);
#line 26 "zooext.c"
    
/* @(#) various.h 2.3 87/12/27 14:44:34 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/

/*
This files gives definitions for most external functions used by Zoo.
If ANSI_PROTO is defined, ANSI-style function prototypes are used, else
normal K&R function declarations are used.

Note:  Always precede this file with an include of stdio.h because it uses
the predefined type FILE.
*/

    #line 25 "various.h"

     /* if not defined in stdio.h */ 
         
/*
 *  string.h	String functions
 *
 *  Copyright (C) by WATCOM Systems Inc. 1988,1989,1990.  All rights reserved.
 */
    

    #line 12 "/usr/include/string.h"

                     
    
  #line 18 "/usr/include/string.h"

    

     /* __INLINE_FUNCTIONS__ */ #line 64 "/usr/include/string.h"

void	*memchr( const void *__s, int __c, size_t __n );
int	 memcmp( const void *__s1, const void *__s2, size_t __n );
void	*memcpy( void *__s1, const void *__s2, size_t __n );
void	*memmove( void *__s1, const void *__s2, size_t __n );
void	*memset( void *__s, int __c, size_t __n );
char	*strcat( char *__s1, const char *__s2 );
char	*strchr( const char *__s, int __c );
int	 strcmp( const char *__s1, const char *__s2 );
int	 strcoll( const char *__s1, const char *__s2 );
char	*strcpy( char *__s1, const char *__s2 );
size_t	 strcspn( const char *__s1, const char *__s2 );
char	*strerror( int __errnum );
size_t	 strlen( const char *__s );
char	*strncat( char *__s1, const char *__s2, size_t __n );
int	 strncmp( const char *__s1, const char *__s2, size_t __n );
char	*strncpy( char *__s1, const char *__s2, size_t __n );
char	*strpbrk( const char *__s1, const char *__s2 );
char	*strrchr( const char *__s, int __c );
size_t	 strspn( const char *__s1, const char *__s2 );
char	*strstr( const char *__s1, const char *__s2 );
char	*strtok( char *__s1, const char *__s2 );
size_t	 strxfrm( char *__s1, const char *__s2, size_t __n );

/* WATCOM's Additional Functions (non-ANSI, non-POSIX) */

               
void __far  *_fmemccpy( void __far *__s1, const void __far *__s2, int __c, size_t __n );
void __far  *_fmemchr( const void __far *__s, int __c, size_t __n );
void __far  *_fmemcpy( void __far *__s1, const void __far *__s2, size_t __n );
void __far  *_fmemmove( void __far *__s1, const void __far *__s2, size_t __n );
void __far  *_fmemset( void __far *__s, int __c, size_t __n );
int	     _fmemcmp( const void __far *__s1, const void __far *__s2, size_t __n );
int	     _fmemicmp( const void __far *__s1, const void __far *__s2, size_t __n );
char __far  *_fstrcat( char __far *__s1, const char __far *__s2 );
char __far  *_fstrchr( const char __far *__s, int __c );
int	     _fstrcmp( const char __far *__s1, const char __far *__s2 );
char __far  *_fstrcpy( char __far *__s1, const char __far *__s2 );
size_t	     _fstrcspn( const char __far *__s1, const char __far *__s2 );
int	     _fstricmp( const char __far *__s1, const char __far *__s2 );
char __far  *_fstrncat( char __far *__s1, const char __far *__s2, size_t __n );
size_t	     _fstrlen( const char __far *__s );
char __far  *_fstrlwr( char __far *__string );
int	     _fstrncmp( const char __far *__s1, const char __far *__s2, size_t __n );
char __far  *_fstrncpy( char __far *__s1, const char __far *__s2, size_t __n );
int	     _fstrnicmp( const char __far *__s1, const char __far *__s2, size_t __n );
char __far  *_fstrnset( char __far *__string, int __c, size_t __len );
char __far  *_fstrpbrk( const char __far *__s1, const char __far *__s2 );
char __far  *_fstrrchr( const char __far *__s, int __c );
char __far  *_fstrrev( char __far *__string );
char __far  *_fstrset( char __far *__string, int __c );
size_t	     _fstrspn( const char __far *__s1, const char __far *__s2 );
char __far  *_fstrstr( const char __far *__s1, const char __far *__s2 );
char __far  *_fstrtok( char __far *__s1, const char __far *__s2 );
char __far  *_fstrupr( char __far *__string );
void	    *memccpy( void *__s1, const void *__s2, int __c, size_t __n );
int	     memicmp( const void*__s1, const void *__s2, size_t __n );
void	     movedata( unsigned __srcseg, unsigned __srcoff,
		     unsigned __tgtseg, unsigned __tgtoff, unsigned __len );
int	     strcmpi( const char *__s1, const char *__s2 );
char	    *strdup( const char *__string );
int	     stricmp( const char *__s1, const char *__s2 );
char	    *strlwr( char *__string );
int	     strnicmp( const char *__s1, const char *__s2, size_t __n );
char	    *strnset( char *__string, int __c, size_t __len );
char	    *strrev( char *__string );
char	    *strset( char *__string, int __c );
char	    *strupr( char *__string );
   /* _QNX_SOURCE || !NO_EXT_KEYS */ 

/* Quantum's Additional Functions (non-ANSI, non-POSIX) */

               
void	 __strerror( int __max, int __errnum, char *__buf );
    
extern int (__far * (__far *__f)) ();
          
  
   /* _QNX_SOURCE || !NO_EXT_KEYS */ 

   /* __STDC__ */ #line 183 "/usr/include/string.h"

   
  
#line 28 "various.h"
         
/*
 *  stdlib.h    Standard Library functions
 *
 *  Copyright (C) by WATCOM Systems Inc. 1988,1989,1990.  All rights reserved.
 *  Copyright (C) by Quantum Software Systems 1990.  All rights reserved.
 */
    

 #pragma pack(1);

    #line 15 "/usr/include/stdlib.h"

    
    
 typedef unsigned short wchar_t;
  

                     
    
  #line 26 "/usr/include/stdlib.h"

   
   
   
   

typedef struct  {
        int     quot;
        int     rem;
} div_t;

typedef struct  {
        long    quot;
        long    rem;
} ldiv_t;

    

    #line 52 "/usr/include/stdlib.h"

 #pragma aux     abort   aborts;
 #pragma aux     exit    aborts;

void             abort( void );
int              abs( int __j );
int              atexit( void ( *__func )( void ) );
double           atof( const char *__nptr );
int              atoi( const char *__nptr );
long int         atol( const char *__nptr );
void            *bsearch( const void *__key, const void *__base,
                    size_t __nmemb, size_t __size,
                    int ( *__compar )( const void *__pkey, const void *__pbase ) );
void            *calloc( size_t __n, size_t __size );
div_t            div( int __numer, int __denom );
void             exit( int __status );
void             free( void *__ptr );
char            *getenv( const char *__name );
long int         labs( long int __j );
ldiv_t           ldiv( long int __numer, long int __denom );
void            *malloc( size_t __size );
int              mblen( const char *__s, size_t __n );
size_t           mbstowcs( wchar_t *__pwcs, const char *__s, size_t __n );
int              mbtowc( wchar_t *__pwc, const char *__s, size_t __n );
void             qsort( void *__base, size_t __nmemb, size_t __size,
                    int (*__compar)( const void *, const void * ) );
int              rand( void );
void            *realloc( void *__ptr, size_t __size );
void             srand( unsigned int __seed );
double           strtod( const char *__nptr, char **__endptr );
long int         strtol( const char *__nptr, char **__endptr, int __base );
unsigned long    strtoul( const char *__nptr, char **__endptr, int __base );
int              system( const char *__string );
size_t           wcstombs( char *__s, const wchar_t *__pwcs, size_t __n );
int              wctomb( char *__s, wchar_t __wchar );

      

                      
 #pragma aux      _exit   aborts;
void             _exit( int __status );
  

               
    #line 108 "/usr/include/stdlib.h"
/*
 * The following sizes are the maximum sizes of buffers used by the _makepath()
 * and _splitpath() functions.  They include space for the '\0' terminator.
 */

   /*  maximum length of path name         */
   /*  maximum length of node name w/ '\0' */
   /*  maximum length of node name w/ '\0' */
   /*  maximum length of subdirectory      */
   /*  maximum length of a file name       */
   /*  maximum length of a file extension  */

extern char **__near environ;   /*  pointer to environment table        */ 

/* min and max macros */
        
        

unsigned         atoh( const char *__nptr );
char            *ecvt( double __val, int __ndig, int *__dec, int *__sign );
char             fcvt( double __val, int __ndig, int *__dec, int *__sign );
char        *_fullpath(char *__buf,const char *__path,size_t __size);
char             gcvt( double __val, int __ndig, char *__buf );
char            *itoa( int __value, char *__buf, int __radix );
unsigned long    _lrotl( unsigned long __value, unsigned int __shift );
unsigned long    _lrotr( unsigned long __value, unsigned int __shift );
char            *ltoa( long int __value, char *__buf, int __radix );
void             _makepath( char *__path, const char *__drive, const char *__dir,
                    const char *__fname, const char *__ext );
int              need_usage( char **argv );
typedef void     (*onexit_t)( );
onexit_t         onexit( onexit_t __func );
int              putenv( const char *__string );
unsigned int     _rotl( unsigned int __value, unsigned int __shift );
unsigned int     _rotr( unsigned int __value, unsigned int __shift );
void __near     *sbrk( int __increment );
void             _searchenv( const char *__name, const char *__env_var,
                    char *__buf );
void             searchenv( const char *__name, const char *__env_var,
                    char *__buf );
void             _splitpath( const char *__path, char *__drive,
                    char *__dir, char *__fname, char *__ext );
void             swab( char *__src, char *__dest, int __num );
char            *ultoa( unsigned long int __value, char *__buf, int __radix );
int              print_usage( char **argv );
char            *utoa( unsigned int __value, char *__buf, int __radix );
   /* _QNX_SOURCE || !NO_EXT_KEYS */ 

   
extern volatile int          (*__get_errno_ptr());      /*  ANSI error number               */ 
extern unsigned char __near _osmajor;   /*  O/S version #                   */ 
extern unsigned char __near _osminor;   /*  O/S version #                   */ 
extern unsigned __near      _amblksiz;  /*  mallocs done in multiples of    */ 

   /* __STDC__ */ #line 171 "/usr/include/stdlib.h"

 #pragma pack();

   
  
#line 29 "various.h"
   /* ! ANSI_HDRS */ #line 75 "various.h"

#line 27 "zooext.c"

    
        
/*
 *  signal.h	Signal definitions
 *
 *  Copyright (C) by WATCOM Systems Inc. 1990.	All rights reserved.
 *  Copyright (C) by Quantum Software Systems 1990.  All rights reserved.
 */
    

    
           
/*
 *  types.h	Defined system types
 *
 *  Copyright (C) by Quantum Software Systems 1990.  All rights reserved.
 */
    
     
  typedef unsigned long time_t; 	/* time value			    */ 
   #line 12 "/usr/include/sys/types.h"
    
  

    #line 19 "/usr/include/sys/types.h"

    
    
     
  typedef signed ssize_t;
   #line 27 "/usr/include/sys/types.h"
  

    

/* Define POSIX 1003.1 types */

typedef long		dev_t;		/* Combination of node and device   */ 
    
 typedef short unsigned gid_t;		/* Used for group IDs		    */ 
    
  
typedef long		ino_t;		/* Used for file serial numbers     */ 
typedef short unsigned	mode_t; 	/* Used for some file attributes    */ 
typedef short unsigned	nlink_t;	/* Used for link counts 	    */ 
typedef long		off_t;		/* Used for file sizes, offsets     */ 
typedef short int	pid_t;		/* Used for process IDs & group IDs */ 
    
 typedef short unsigned uid_t;		/* Used for user IDs		    */ 
    
  
               
typedef short unsigned	msg_t;		/* Used for message passing	    */ 
typedef long		nid_t;		/* Used for network IDs 	    */ 
typedef short int	timer_t;	/* Used for timer IDs		    */ 
  

     /* __STDC__ */ #line 70 "/usr/include/sys/types.h"

   
  


#line 11 "/usr/include/signal.h"
  

typedef int	sig_atomic_t;

                      
typedef long	sigset_t;	/* Used for signal sets 	    */ 

struct sigaction {
    
    void	(__far *sa_handler)();
  #line 25 "/usr/include/signal.h"
    sigset_t	sa_mask;
    int 	sa_flags;
};
   /* _POSIX_SOURCE || _QNX_SOURCE || !NO_EXT_KEYS */ 

    

   
   
   
   

   
   
   
   

  #line 50 "/usr/include/signal.h"

   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   /*	Not supported */
   
   /*	Not supported */
   /*	Not supported */
   

   
   

   

   
   
   

    
void	(*signal( int __sig, void (*__func)(int) ))(int);
int	raise( int __sig );
                      
int	kill( pid_t __pid, int __signum );
int	sigaction( int __signo, const struct sigaction *__act, struct sigaction *__oact );
int	sigaddset( sigset_t *__set, int __signo );
int	sigdelset( sigset_t *__set, int __signo );
int	sigemptyset( sigset_t *__set );
int	sigfillset( sigset_t *__set );
int	sigismember( sigset_t *__set, int __signo );
int	sigpending( sigset_t *__set );
int	sigprocmask( int __how, const sigset_t *__set, sigset_t *__oset );
int	sigsuspend( const sigset_t *sigmask );
   /* _POSIX_SOURCE || _QNX_SOURCE || !NO_EXT_KEYS */ 
   /* __STDC__ */ 

   
  



#line 30 "zooext.c"
  

    
/* @(#) zoofns.h 2.5 88/01/16 19:03:13 */
/* @(#) zoofns.h 2.7 88/01/27 19:39:18 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/

/* Defines function declarations for all Zoo functions */

    #line 19 "zoofns.h"

/* 
:.,$s/(PARMS\(.*\));/PARMS\1;/
*/
    
        
/*
 *  stdlib.h    Standard Library functions
 *
 *  Copyright (C) by WATCOM Systems Inc. 1988,1989,1990.  All rights reserved.
 *  Copyright (C) by Quantum Software Systems 1990.  All rights reserved.
 */
    #line 176 "/usr/include/stdlib.h"
#line 25 "zoofns.h"
   /* ANSI_HDRS */ #line 28 "zoofns.h"

long calc_ofs   (char *);
char *addext   (char *, char *);
char *combine   (char[], char *, char *);
 char * emalloc   (unsigned int);
 char * ealloc   (unsigned int);
 char * erealloc   (char *, unsigned int);
char *findlast   (char *, char *);
char *fixfname   (char *);
char *getstdin   (void);
char *lastptr   (char *);
char *nameptr   (char *);
char *newcat   (char *, char *);
char *nextfile   (int, char *, int);
int cfactor   (long, long);
int chname   (char *, char *);
int cmpnum   (unsigned int, unsigned int, unsigned int, unsigned int);
 void ctrl_c   (void);
int exists   (char *);
int getfile   (ZOOFILE, ZOOFILE, long, int);
int getutime   (char *, unsigned *, unsigned *);
int gettime   (ZOOFILE, unsigned *, unsigned *);
 void handle_break   (void);

     /* USE_ASCII */ #line 56 "zoofns.h"

int kill_files   (char *[], int);
    #line 62 "zoofns.h"
int lzc   (ZOOFILE, ZOOFILE);
int lzd   (ZOOFILE, ZOOFILE);
  

int lzh_encode  (FILE *infile, FILE *outfile);
int lzh_decode  (FILE *infile, FILE *outfile);

int match_half   (char *, char *);
int samefile   (char *, char *);
int settime   (ZOOFILE, unsigned, unsigned);
int setutime   (char *, unsigned, unsigned);
int str_icmp   (char *, char *);

     /* USE_ASCII */ #line 79 "zoofns.h"

void zooexit   (int);
long inlist   (char *, unsigned int *, unsigned int *, unsigned *, unsigned *, unsigned *, long *, int);
unsigned long space   (int, int *);
void addbfcrc   (char *, int);
void addfname   (char *, long, unsigned int, unsigned int, unsigned, unsigned);
void add_version   (char *, struct direntry *);
void basename   (char *, char []);
void break_off   (void);
void close_file   (ZOOFILE);
void comment   (char *, char *);
void extension   (char *, char []);
void exit   (int);
void fixslash   (char *);
void makelist   (int, char *[], char *[], int, char *, char *, char *, int *);
void memerr   (unsigned int);
void prterror   (int, char *, ...);
void rootname   (char *, char *);
void skip_files   (ZOOFILE, unsigned int *, unsigned int *, int *, char [], long *);
void writenull   (ZOOFILE, int);
void zooadd   (char *, int, char **, char *);
void zoodel   (char *, char *, int);
void zoofilt   (char *);
void zooext   (char *, char *);
void zoolist   (char **, char *, int);
void zoopack   (char *, char *);

char *str_dup   (char *);
char *str_lwr   (char *);

#line 33 "zooext.c"

    #line 37 "zooext.c"

void makepath  (char *);
int needed  (char *, struct direntry *, struct zoo_header *);
void putstr  (char *);

     /* FATTR */ #line 45 "zooext.c"

extern int quiet;

    
/* @(#) errors.i 2.4 88/01/31 12:32:46 */

/*
The contents of this file are hereby released to the public domain.

                           -- Rahul Dhesi 1986/11/14
*/

/* defines all the errors as externs.  Declarations must be
equivalent to those in prterror.c */

/* These declarations must be equivalent to those in prterror.c */
extern char no_match[];
extern char failed_consistency[];
extern char invalid_header[];
extern char internal_error[];
extern char disk_full[];
extern char bad_directory[];
extern char no_memory[];
extern char too_many_files[];
extern char packfirst[];
extern char garbled[];
extern char start_ofs[];

    
extern char wrong_version[];
extern char cant_process[];
extern char option_ignored[];
extern char inv_option[];
extern char bad_crc[];
  

extern char could_not_open[];

#line 49 "zooext.c"

/* Following two are used by ctrl_c() also, hence declared here */
char extfname[ 256];             /* filename of extracted file */ 
char prtfname[ 256];             /* name of extracted file on screen */ 
static ZOOFILE this_file;              /* file to extract */ 

static int tofile;                     /* true if not pipe or null device */ 
extern unsigned int crccode;
extern char *out_buf_adr;              /* address of output buffer */ 

void zooext(zoo_path, option)
char *zoo_path, *option;
{
char *whichname;                          /* which name to extract */ 
char matchname[ 256];                 /* for pattern matching only */ 
    
 void (*oldsignal)();        /* to save previous SIGINT handler */ 
  
ZOOFILE zoo_file;                         /* open archive */ 
long next_ptr;                            /* pointer to within archive */ 
struct zoo_header zoo_header;             /* header for archive */ 
int status;                               /* error status */ 
int exit_status = 0;								/* exit status */ 
int error_message;								/* Whether to give error message */ 
unsigned long disk_space;                 /* disk space left */ 
int matched = 0;                          /* Any files matched? */ 
int overwrite = 0;                        /* force overwrite of files? */ 
int supersede = 0;								/* supersede newer files? */ 
int needdel = 0;                          /* extract deleted files too */ 
int usepath = 2;                          /* use path for extraction */ 
int todot = 0;                            /* extract relative to . */ 
int badcrc_count = 0;                     /* how many files with bad CRC */ 
int bad_header = 0;                       /* to avoid spurious messages later */ 
long fiz_ofs = 0;                         /* offset where to start */ 
long dat_ofs = 0;									/* .. and offset of file data */ 
int pipe = 0;                             /* are we piping output? */ 
int null_device = 0;                      /* are we sending to null device? */ 
    #line 90 "zooext.c"
struct direntry direntry;                 /* directory entry */ 
int first_dir = 1;								/* first dir entry seen? */ 

static char extract_ver[] = "Zoo %d.%d is needed to extract %s.\n";
static char no_space[] = "Insufficient disk space to extract %s.\n";

while (*option) {
   switch (*option) {
    #line 101 "zooext.c"
      case 'x':
      case 'e': break;
      case 'N': null_device++; break;
      case 'O': overwrite += 2; break;
      case 'o': overwrite++; break;
      case 'p': pipe++; break;
		case 'S': supersede++; break;
      case 'd': needdel++; break;
      case 'q': quiet++; break;
		case ':': usepath = 0; break;
      case '/': usepath++; break;
      case '.': todot++; break;
      case '@': 	/* if @m,n specified, fiz_ofs = m, dat_ofs = n */ 
			{
				char *comma_pos;
				++option;
				comma_pos = strchr(option, ',');
				if (comma_pos !=  0) {
					dat_ofs = calc_ofs (comma_pos + 1);
					*comma_pos = '\0';
				}
				fiz_ofs = calc_ofs(option); 
				goto no_more;
			}
      default:
         prterror ('f', inv_option, *option);
         /* break; */
   }
   option++;
}

no_more: /* come from exit in while loop above */ 


if (overwrite == 1)                 /* must be at least 2 to begin with */ 
   overwrite--;

if (null_device && pipe) {
   prterror ('f', inv_option, 'p');
   pipe = 0;
}

if (overwrite && pipe)
   prterror ('w', option_ignored, 'O');

    #line 152 "zooext.c"

tofile = !pipe && !null_device;     /* sending to actual file */ 

zoo_file = zooopen(zoo_path,  "r");

if (zoo_file ==  ((ZOOFILE) 0))
   prterror ('f', could_not_open, zoo_path);

if (fiz_ofs != 0L) {                /* if offset specified, start there */ 
	prterror ('m', start_ofs, fiz_ofs, dat_ofs);
     fseek (zoo_file, fiz_ofs, 0);
} else {
   /* read header */
   frd_zooh (&zoo_header, zoo_file);
   if ((zoo_header.zoo_start + zoo_header.zoo_minus) != 0L) {
      prterror ('w', failed_consistency);
      bad_header++;
		exit_status = 1;
   }
     fseek (zoo_file, zoo_header.zoo_start, 0); /* seek to where data begins */ 
}

    #line 177 "zooext.c"
disk_space =  ((unsigned long) (~0L));              /* infinite disk space */ 
  

/* if piping output we open the output device just once */
if (null_device) {
   this_file =  ((ZOOFILE) -1);
} else if (pipe)
   this_file =  ((FILE *)&__iob[1]);    /* standard output */ 

while (1) {
   frd_dir (&direntry, zoo_file);
   if (direntry.zoo_tag !=  ((unsigned long) 0xFDC4A7DCL)) {
      long currpos, zoolength;
		prterror ('F', invalid_header);

		/* Note:  if header was bad, there's no point trying to find
			how many more bytes aren't processed -- our seek position is
			likely very wrong */

		if (!bad_header)
			if ((currpos =   ftell (zoo_file)) != -1L)
				if (  fseek (zoo_file, 0L, 2) != -1)
					if ((zoolength =   ftell (zoo_file)) != -1L)
						printf (cant_process, zoolength - currpos);              
		zooexit (1);
   }
   if (direntry.next == 0L) {                /* END OF CHAIN */ 
      break;                                 /* EXIT on end of chain */ 
   }
	/* when first direntry read, change dat_ofs from abs. pos. to rel. offset */
	if (first_dir && dat_ofs != 0) {
		dat_ofs -= direntry.offset;
		first_dir = 0;
	}
   next_ptr = direntry.next + dat_ofs;       /* ptr to next dir entry */ 

   whichname = choosefname(&direntry);       /* which filename */ 
	whichname = str_dup(whichname);				/* bug fix */ 
   fixfname(whichname);                      /* fix syntax */ 
	strcpy (matchname, fullpath (&direntry));	/* get full pathname */ 
	if (zoo_header.vdata &  0x80)
		add_version (matchname, &direntry);		/* add version suffix */ 

/* if extraction to subtree rooted at curr dir, modify pathname */
     #line 233 "zooext.c"

   /* hard-coded '/' should be eventually removed */
   if (todot && *direntry.dirname == '/') { 
      char tmpstr[ 256];
      strcpy(tmpstr, direntry.dirname);
      strcpy(direntry.dirname, ".");
      strcat(direntry.dirname, tmpstr);
   }

   /* matchname now holds the full pathname for pattern matching */

   if ( ( (needdel && direntry.deleted) ||
            (needdel < 2 && !direntry.deleted)
        ) && needed(matchname, &direntry, &zoo_header)) {
      matched++;           /* update count of files extracted */ 

      if (direntry.major_ver >  2 ||
         (direntry.major_ver ==  2 && 
            direntry.minor_ver >  1)) {
            prterror ('e', extract_ver, direntry.major_ver, 
                           direntry.minor_ver, whichname);
				exit_status = 1;
            goto loop_again;
      }

      /* 
      If extracting to null device, or if user requested extraction
      of entire path, include any directory name in filename.
      If extraction to current directory requested, and if extfname
      begins with path separator, fix it */

      strcpy (extfname, whichname);
      if ((usepath || null_device) && direntry.dirlen != 0) {
         combine(extfname, direntry.dirname, whichname);
         if (usepath > 1 && !null_device)
            makepath(direntry.dirname);         /* make dir prefix */ 
      }

		strcpy(prtfname, extfname);
		if (zoo_header.vdata &  0x80)
			add_version (prtfname, &direntry);

      if (tofile) {
         int present = 0;

     /* ifndef PORTABLE */ #line 309 "zooext.c"

			/* don't extract if archived file is older than disk copy */
			if (!supersede && exists(extfname)) {
				unsigned int ddate, dtime;
    #line 316 "zooext.c"
				ZOOFILE tfile;
				ddate = dtime = 0xffff;					/* assume maximum */ 
				tfile = zooopen(extfname,  "r");
				if (tfile ==  ((ZOOFILE) 0))
					goto loop_again;
				gettime (tfile, &ddate, &dtime);
				zooclose (tfile);
  
				if (cmpnum (direntry.date, direntry.time, ddate, dtime) <= 0) {
					prterror ('m', "%-14s -- skipped\n", prtfname);
					goto loop_again;
				}
			}

         if (overwrite) {
            this_file = zoocreate (extfname);
     /* FATTR */ #line 340 "zooext.c"
         } else {
            if (exists (extfname)) {
               present = 1;
               this_file =  ((ZOOFILE) 0);
            } else
               this_file = zoocreate (extfname);
         }
			error_message = 1;
         if (this_file ==  ((ZOOFILE) 0)) {
            if (present == 1) {      /* if file exists already */ 
					char ans[20];          /* answer to "Overwrite?" */ 
               do {
    #line 356 "zooext.c"
                  printf ("Overwrite %s (Yes/No/All)? ", extfname);
  
                  fflush ( ((FILE *)&__iob[0]));
                  fgets (ans, sizeof(ans),  ((FILE *)&__iob[0]));
                  str_lwr (ans);
               } while (*ans != 'y' && *ans != 'n' && *ans != 'a');
   
               if (*ans == 'a')
                  overwrite++;
               if (*ans == 'y' || *ans == 'a') {
                  this_file = zoocreate(extfname);
                  error_message = 1; /* give error message if open fails */ 
               } else {
                  error_message = 0; /* user said 'n', so no error message */ 
               }
            } else {
               error_message = 1;   /* Real error -- give error message */ 
            }
         } /* end if */ 
      } /* end if */ 

      if (this_file ==  ((ZOOFILE) 0)) {         /* file couldn't be opened */ 
         if (error_message == 1) {
            prterror ('e', "Can't open %s for output.\n", extfname);
				exit_status = 1;

    #line 387 "zooext.c"

         }
      } else if (  fseek (zoo_file, (direntry.offset + dat_ofs), 0) == -1L) {
         prterror ('e', "Could not seek to file data.\n");
			exit_status = 1;
         close_file (this_file);
      } else {
    #line 406 "zooext.c"
         if (tofile && disk_space < direntry.org_size) {
    
            ;
   /* portable */ #line 413 "zooext.c"

         } else { 

     /* ifndef PORTABLE */ #line 433 "zooext.c"

            crccode = 0;      /* Initialize CRC before extraction */ 
               if (!pipe) {
    
                  prterror ('m', "%-14s -- ", prtfname);
   /* PORTABLE */ #line 445 "zooext.c"

               } else {            /* must be pipe */ 
                  prterror ('M',"\n\n********\n%s\n********\n",prtfname);

    #line 453 "zooext.c"
               }
    
            if (tofile)
               {
                  oldsignal = signal ( 2,  ((void(*)())((void(__far *)())(unsigned int)1)));
                  if (oldsignal !=  ((void(*)())((void(__far *)())(unsigned int)1))) 
                     signal ( 2, ctrl_c); /* Trap ^C & erase partial file */ 
               }
   /* not NOSIGNAL */ 

            if (direntry.packing_method == 0)
               /* 4th param 1 means CRC update */
               status = getfile (zoo_file, this_file, direntry.size_now, 1);

    #line 472 "zooext.c"

            else if (direntry.packing_method == 1) {
    #line 496 "zooext.c"
               status = lzd (zoo_file, this_file); 	/* uncompress */ 
  
				} else if (direntry.packing_method == 2) {
               status = lzh_decode (zoo_file, this_file);
            } else {
               prterror ('e', "File %s:  impossible packing method.\n",
                  whichname);
                  unlink(extfname);
                  goto loop_again;
            }


    
            if (tofile)
               signal ( 2, oldsignal);
   /* not NOSIGNAL */ 

    #line 517 "zooext.c"
   
            if (tofile) {
               /* set date/time of file being extracted */
    
					void tzadj();
					/* adjust for original timezone */
					tzadj (&direntry);
  
    
               close_file (this_file);
               setutime (extfname, direntry.date, direntry.time);
  #line 532 "zooext.c"
     /* FATTR */ #line 544 "zooext.c"
            } /* end of if (tofile) ... */ 
            if (status != 0) {
					exit_status = 1;
               if (tofile)
                  unlink (extfname);
               if (status == 2) {	/* was 1 (wrong) */ 
                  memerr(0);
               /* To avoid spurious errors due to ^Z being sent to screen,
                  we don't check for I/O error if output was piped */
               } else if (!pipe && (status == 2 || status == 3)) {
                     prterror ('e', no_space, prtfname);
               }
            } else {
               /* file extracted, so update disk space.  */
               /* we subtract the original size of the file, rounded
                  UP to the nearest multiple of the disk allocation
                  size. */
    #line 568 "zooext.c"

               if (
    #line 573 "zooext.c"
							direntry.file_crc != crccode
						) {
                  badcrc_count++;
						exit_status = 1;
                  if (!pipe) {
                     if (!null_device)
                        prterror ('M', "extracted   ");
                     prterror ('w', bad_crc, prtfname);
                  }
                  else {   /* duplicate to standard error */ 
                     static char stars[] = "\n******\n";
                     putstr (stars);
                     prterror ('w', bad_crc, prtfname);
                     putstr (stars);
                     fprintf ( ((FILE *)&__iob[2]), "WARNING:  ");
                     fprintf ( ((FILE *)&__iob[2]), bad_crc, prtfname);
                  }
               } else
                  if (!pipe)
                     prterror ('M', null_device ? "OK\n" : "extracted\n");

            } /* end if */ 
         } /* end if */ 
      } /* end if */ 
   } /* end if */ 

loop_again:
     fseek (zoo_file, next_ptr, 0); /* ..seek to next dir entry */ 
} /* end while */ 

close_file (zoo_file);
if (!matched)
   putstr (no_match);

if (badcrc_count) {
   prterror ('w', "%d File(s) with bad CRC.\n", badcrc_count);
} else if (null_device)
   prterror ('m', "Archive seems OK.\n");

zooexit (exit_status);

} /* end zooext */ 

/* close_file() */
/* closes a file if and only if we aren't sending output to 
   a pipe or to the null device */

void close_file (file)
ZOOFILE file;
{
   if (tofile)
      zooclose (file);
}

/* Ctrl_c() is called if ^C is hit while a file is being extracted.
   It closes the files, deletes it, and exits. */
 void ctrl_c()
{
    
   signal ( 2,  ((void(*)())((void(__far *)())(unsigned int)1)));     /* ignore any more */ 
  
   zooclose (this_file);
   unlink (extfname);
   zooexit (1);
}

     /* ifndef PORTABLE */ #line 659 "zooext.c"
